export LC_ALL=C LANG=C
-data_dirs(){
- # create directories for object storage
-
- [ -d "$_DATA" -a -w "$_DATA" ] || die "storage directory must be writable"
- for each in "$@"; do
- [ ! -e "$_DATA/$each" ] && mkdir "$_DATA/$each"
- [ -d "$_DATA/$each" -a -w "$_DATA/$each" ] || die "storage \"$_DATA/$each\" must be a writable directory"
- done
-}
-
# this program is supposed to be symlinked into a http root directory
# we will use the http root as object storage (data directory) and call sub
# programs from the directory in which the real executable resides
_DATA="$(dirname "$call")" #storage directory
_EXEC="${real%/shcgi/index.cgi}" #execution directory
+. "$_EXEC/shcgi/misc.sh"
# put debug options in the local.opts file
. "$_EXEC/shcgi/debug.sh"
[ -r "$_DATA/local.opts" ] && . "$_DATA/local.opts"
--- /dev/null
+#!/bin/zsh
+
+# Copyright 2014, 2015 Paul Hänsch
+#
+# This file is part of shcgi.
+#
+# shcgi is free software: you can redistribute it and/or modify
+# it under the terms of the GNU Affero General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# shcgi is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU Affero General Public License for more details.
+#
+# You should have received a copy of the GNU Affero General Public License
+# along with shcgi. If not, see <http://www.gnu.org/licenses/>.
+
+data_dirs(){
+ # set up directories for object storage
+
+ [ -d "$_DATA" -a -w "$_DATA" ] || die "storage directory must be writable"
+ for each in "$@"; do
+ [ ! -e "$_DATA/$each" ] && mkdir "$_DATA/$each"
+ [ -d "$_DATA/$each" -a -w "$_DATA/$each" ] || die "storage \"$_DATA/$each\" must be a writable directory"
+ done
+}
+
+validate(){
+ # print value if value matches regex; otherwise print default
+ value="$1"
+ regex="$(printf %s\\n "$2" \
+ | sed -r 's;(^|[^\\]+)((\\\\)+)/;\1\2\\/;g; s;(^|[^\\])/;\1\\/;g; s;(^|[^\\]+)((\\\\)+)/;\1\2\\/;g; s;(^|[^\\])/;\1\\/;g;'
+ )" # ^^ escape only unescaped slash characters for later insertion
+ default="$3"
+
+ printf %s\\n "${value}" \
+ | sed -rn "2q; /^(${regex})\$/{p;q}; a${default}"
+}